#ifndef Loader_hpp
#define Loader_hpp

#include "Link.hpp"

namespace SoftWire
{
	class Linker;
	class Encoding;

	class Loader
	{
	public:
		Loader(const Linker &linker);

		~Loader();

		const void (*callable(const char *entryLabel = 0))();

		void appendEncoding(const Encoding &encoding);

		const char *getListing();
		void clearListing();

	private:
		const Linker &linker;

		typedef Link<Encoding> Instruction;
		Instruction *instructions;
		unsigned char *machineCode;
		char *listing;

		void loadCode(const char *entryLabel = 0);
		const unsigned char *resolveReference(const char *name) const;
		const unsigned char *resolveLocal(const char *name) const;
		const unsigned char *resolveExternal(const char *name) const;
		int codeLength() const;
	};
}

#endif   // Loader_hpp
